﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Globalization;
using System.Reflection;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.ServiceModel.Web;
using System.Text;
using Seven.DSS.Globals;
using Seven.DSS.Business;
using Seven.DSS.Objects;

namespace Seven.DSS
{
    [ServiceContract(Namespace = "SevenIPMWS")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class Maestro
    {
        #region Accordion

        [WebGet]
        [OperationContract]
        public string GetAccordionForm(string U, string N, string D, string I, string LangCode, string SubDir)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    string Dir = "src=\"";

                    if (int.Parse(SubDir) == 1)
                    {
                        Dir = "src=\"../";
                    }

                    return ("<div id=\"SevenMenu\">\n" +
                                Logica.GetAccordion(1, iden.U, LangCode, iden).Replace("$HAYOPCIONES$", "") +
                            "</div>\n" +
                            "<table width=\"100%\">\n" +
                                "<tr>\n" +
                                    "<td width=\"50%\">\n" +
                                        "<button type=\"submit\" style=\"width: 100%;\">" +
                                            "<table>" +
                                                "<tr>" +
                                                    "<td><img src=\"img/disk.png\" /></td>" +
                                                    "<td><span style=\"font-size: 8pt;\">" + L.LBL("LblGENSave") + "</span></td>" +
                                                "</tr>" +
                                            "</table>" +
                                        "</button>" +
                                    "</td>\n" +
                                    "<td width=\"50%\">\n" +
                                        "<button type=\"button\" onclick=\"mostrarAjaxAccordion();\" style=\"width: 100%;\">" +
                                            "<table>" +
                                                "<tr>" +
                                                    "<td><img src=\"img/arrow-return-180-left.png\" /></td>" +
                                                    "<td><span style=\"font-size: 8pt;\">" + L.LBL("LblGENCancel") + "</span></td>" +
                                                "</tr>" +
                                            "</table>" +
                                        "</button>" +
                                    "</td>\n" +
                                "</tr>\n" +
                            "</table>\n")
                            .Replace("src=\"", Dir);
                }
                else
                {
                    throw new Exception("LblGENWrongUserSession");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + "</b></br> " + Memoria.Error + "\n" + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        [WebGet]
        [OperationContract]
        public string GetAccordion(string U, string N, string D, string I, string LangCode, string SubDir)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    string Dir = "src=\"";

                    if (int.Parse(SubDir) == 1)
                    {
                        Dir = "src=\"../";
                    }

                    return ("<div id=\"SevenMenu\">\n" +
                                Logica.GetAccordion(0, 0, LangCode, iden).Replace("$HAYOPCIONES$", "") +
                            "</div>\n" +
                            "<button type=\"button\" onclick=\"mostrarAjaxAccordionUser();\" style=\"width: 100%;\">" +
                                "<table>" +
                                    "<tr>" +
                                        "<td><img src=\"img/user.png\" /></td>" +
                                        "<td>" + L.LBL("LblGENCustomizeMyMenu") + "</td>" +
                                    "</tr>" +
                                "</table>" +
                            "</button>")
                            .Replace("src=\"", Dir);
                }
                else
                {
                    throw new Exception("LblGENWrongUserSession");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + "</b></br> " + Memoria.Error + "\n" + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        [WebGet]
        [OperationContract]
        public string GetMenu(string U, string N, string D, string I, string LangCode, int SubDir)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    CultureInfo ciLocal = new CultureInfo(LangCode);

                    //string Dir = "src=\"";

                    //if (SubDir == 1)
                    //{
                    //    Dir = "src=\"../";
                    //}

                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetMenu(0, 0, LangCode, iden));
                    //$("#MenuP ul").append('<li><a href="#tabs-' + i + '"><img src="img/' + datos.rows[i].cell[1] + '" />' + datos.rows[i].cell[2] + '</a></li>');

                    //return ("<div id=\"SevenMenu\">\n" +
                    //            Logica.GetAccordion(0, 0, LangCode, iden).Replace("$HAYOPCIONES$", "") +
                    //        "</div>\n" +
                    //        "<button type=\"button\" onclick=\"mostrarAjaxAccordionUser();\" style=\"width: 100%;\">" +
                    //            "<table>" +
                    //                "<tr>" +
                    //                    "<td><img src=\"img/user.png\" /></td>" +
                    //                    "<td><span style=\"font-size: 8pt;\">LblGENCustomizeMyMenu</span></td>" +
                    //                "</tr>" +
                    //            "</table>" +
                    //        "</button>")
                    //        .Replace("LblGENCustomizeMyMenu", L.LBL("LblGENCustomizeMyMenu"))
                    //        .Replace("src=\"", Dir);
                }
                else
                {
                    CultureInfo ciLocal = new CultureInfo(LangCode);
                    throw new Exception(L.ERR("LblGENWrongUserSession"));
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(ex.Message, 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = ex.Message,
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                CultureInfo ciLocal = new CultureInfo(LangCode);
                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + ":</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        [WebGet]
        [OperationContract]
        public string GetMenuP(string U, string N, string D, string I, string LangCode, int SubDir)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    CultureInfo ciLocal = new CultureInfo(LangCode);

                    //string Dir = "src=\"";

                    //if (SubDir == 1)
                    //{
                    //    Dir = "src=\"../";
                    //}

                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetMenu(1, iden.U, LangCode, iden));
                    //$("#MenuP ul").append('<li><a href="#tabs-' + i + '"><img src="img/' + datos.rows[i].cell[1] + '" />' + datos.rows[i].cell[2] + '</a></li>');

                    //return ("<div id=\"SevenMenu\">\n" +
                    //            Logica.GetAccordion(0, 0, LangCode, iden).Replace("$HAYOPCIONES$", "") +
                    //        "</div>\n" +
                    //        "<button type=\"button\" onclick=\"mostrarAjaxAccordionUser();\" style=\"width: 100%;\">" +
                    //            "<table>" +
                    //                "<tr>" +
                    //                    "<td><img src=\"img/user.png\" /></td>" +
                    //                    "<td><span style=\"font-size: 8pt;\">LblGENCustomizeMyMenu</span></td>" +
                    //                "</tr>" +
                    //            "</table>" +
                    //        "</button>")
                    //        .Replace("LblGENCustomizeMyMenu", L.LBL("LblGENCustomizeMyMenu"))
                    //        .Replace("src=\"", Dir);
                }
                else
                {
                    CultureInfo ciLocal = new CultureInfo(LangCode);
                    throw new Exception(L.ERR("LblGENWrongUserSession"));
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(ex.Message, 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = ex.Message,
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                CultureInfo ciLocal = new CultureInfo(LangCode);
                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + ":</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #region Seguridad

        [WebGet]
        [OperationContract]
        public string ConsultarDatosCombo(string IdJuego, string I)
        {
            try
            {
                if (Seguridad.CargarConfiguracionManagement() == 1)
                {
                    return HTMLSelects.Datos(int.Parse(IdJuego));
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\">" + L.LBL("LblGENWrongQuery") + "</br> " + Memoria.Error + "\n" + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #region EXTERNAL Log Sheet

        [WebGet]
        [OperationContract]
        public string ConsultarLogSheet(string Inicio, string Final, string Pagina, string U, string N, string D, string I)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    DateTime IN = DateTime.Today;
                    try
                    {
                        IN = DateParser.GetDate(Inicio);
                    }
                    catch (Exception) { }
                    DateTime F = DateTime.Today;
                    try
                    {
                        F = DateParser.GetDate(Final);
                    }
                    catch (Exception) { }
                    return Tablas.LogSheet(IN, F, int.Parse(Pagina), iden)
                        .Replace("LblGENDate", L.LBL("LblGENDate"))
                        .Replace("LblGENPermit", L.LBL("LblGENPermit"))
                        .Replace("LblGENObservations", L.LBL("LblGENObservations"))
                        .Replace("LblGENPage", L.LBL("LblGENPage"));
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\">" + L.LBL("LblGENWrongQuery") + "</br> " + Memoria.Error + "\n" + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + Inicio + "F" + Final + Pagina + "</p>";
            }
        }

        #endregion

        #region EXT Monedas

        [WebGet]
        [OperationContract]
        public string ConsultarTasaMoneda(string IdMoneda, string U, string N, string D, string I)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    return (1 / Logica.ConsultarTasaMoneda(int.Parse(IdMoneda), iden)).ToString();
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "0.00";
            }
        }

        [WebGet]
        [OperationContract]
        public string ConsultarTasaMonedaFront(string IdMoneda, string U, string N, string D, string I)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    //return (1 / Logica.ConsultarTasaMonedaFront(IdMoneda)).ToString();
                    return Logica.ConsultarTasaMonedaFront(int.Parse(IdMoneda), iden).ToString();
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "0.00";
            }
        }

        [WebGet]
        [OperationContract]
        public string ConsultarTasaMonedaAcc(string IdEmpresa, string IdMoneda, string U, string N, string D, string I)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    //return (1 / Logica.ConsultarTasaMonedaAcc(IdMoneda, iden)).ToString();
                    return Logica.ConsultarTasaMonedaAcc(int.Parse(IdEmpresa), int.Parse(IdMoneda), iden).ToString();
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "0.00";
            }
        }

        #endregion

        #region Accounting

        [WebGet]
        [OperationContract]
        public string ConsultarEstadoAcc(string U, string N, string D, string I)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    return Tablas.EstadoAcc(iden);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\">" + L.LBL("LblGENWrongQuery") + "</br> " + Memoria.Error + "\n" + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        [WebGet]
        [OperationContract]
        public string ConsultarPeriodosCombo(string IdPeriodo, string Elegir, string U, string N, string D, string I)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    return HTMLSelects.Periodos(int.Parse(IdPeriodo), "", int.Parse(Elegir), "", iden);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\">" + L.LBL("LblGENWrongQuery") + "</br> " + Memoria.Error + "\n" + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        [WebGet]
        [OperationContract]
        public string ConsultarPeriodosComboTodo(string IdPeriodo, string Elegir, string U, string N, string D, string I)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    return HTMLSelects.PeriodosTodo(int.Parse(IdPeriodo), "", int.Parse(Elegir), "", iden);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\">" + L.LBL("LblGENWrongQuery") + "</br> " + Memoria.Error + "\n" + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        [WebGet]
        [OperationContract]
        public string ConsultarPlanCuentasCuXEd(string Pagina, string Consulta, string Dominio, string PorCobrar, string Empresa, string U, string N, string D, string I)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    return Tablas.PlanCuentasCuXEd(int.Parse(Pagina), Consulta, int.Parse(PorCobrar), int.Parse(Empresa)
                        , "window.location.href='RPTACCCuXEd.aspx?b=' + $('#cbEmpresa').val() + '&e=' + $('#cbEjercicio').val() + '&g=' + $('#cbPeriodo').val() "
                        + " + '&i=' + $('input:radio[name=rbPorCobrar]:checked').val() + '&m=' + $('#cbMoneda').val() + '&t=' + $('#txtTasa').val() + '&c=' + '$PRIMARIA';"
                        , iden);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\">" + L.LBL("LblGENWrongQuery") + "</br> " + Memoria.Error + "\n" + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        [WebGet]
        [OperationContract]
        public string ConsultarPlanCuentasExtracto(string Pagina, string Consulta, string Dominio, string CuentaEsp
            , string Empresa, string LibroBancos, string U, string N, string D, string I)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    bool LB = false;
                    if (int.Parse(LibroBancos) == 1) { LB = true; }
                    return Tablas.PlanCuentasExtracto(int.Parse(Pagina), Consulta, int.Parse(CuentaEsp), int.Parse(Empresa)
                        , "window.location.href='RPTAccExtrCuentas.aspx?b=' + $('#IdSubElementCTA').val($PRIMARIA);LibroBancos();", LB, iden);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\">" + L.LBL("LblGENWrongQuery") + "</br> " + Memoria.Error + "\n" + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #region Inventory

        [WebGet]
        [OperationContract]
        public string ConsultarEstadoInv(string U, string N, string D, string I)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    Cache c = MainCache.GetCache(iden.U);
                    return Tablas.EstadoInv(c.IdDatosINV, c.InvEjercicio, iden);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\">" + L.LBL("LblGENWrongQuery") + "</br> " + Memoria.Error + "\n" + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #region Almacén

        [WebGet]
        [OperationContract]
        public string GetAlmacenGrid(string Eliminado, string Dominio, string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    bool Eliminados = false;
                    try
                    {
                        Eliminados = int.Parse(Eliminado) == 0 ? false : true;
                    }
                    catch { }

                    Almacen elemento = new Almacen();
                    elemento.id_alma = 0;

                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetAlmacenGrid(elemento, Eliminados, iden));
                }
                else
                {
                    throw new Exception(L.LBL("LblGENWrongUserSession"));
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(ex.Message, 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = ex.Message,
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + ":</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #region Sección

        [WebGet]
        [OperationContract]
        public string GetSeccionGrid(string Eliminado, string Dominio, string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    bool Eliminados = false;
                    try
                    {
                        Eliminados = int.Parse(Eliminado) == 0 ? false : true;
                    }
                    catch { }

                    Seccion elemento = new Seccion();
                    elemento.id_secc = 0;

                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetSeccionGrid(elemento, Eliminados, iden));
                }
                else
                {
                    throw new Exception(L.LBL("LblGENWrongUserSession"));
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(ex.Message, 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = ex.Message,
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + ":</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #region Artículos

        [WebGet]
        [OperationContract]
        public string GetArticulos_INV(string ArtBusqueda, string Dominio, string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    bool Eliminados = false;

                    Articulo elemento = new Articulo();
                    elemento.descripcion = ArtBusqueda;

                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetArticulos_INV(elemento, Eliminados, iden));
                }
                else
                {
                    throw new Exception(L.LBL("LblGENWrongUserSession"));
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(ex.Message, 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = ex.Message,
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + ":</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        public string GetArticulosAll(string ArtBusqueda, string Dominio, string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    bool Eliminados = false;

                    Articulo elemento = new Articulo();
                    elemento.descripcion = ArtBusqueda;

                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetArticulosAll_INV(elemento, Eliminados, iden));
                }
                else
                {
                    throw new Exception(L.LBL("LblGENWrongUserSession"));
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(ex.Message, 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = ex.Message,
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + ":</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #region Submayor de Articulos

        [WebGet]
        [OperationContract]
        public string GetSubmayorArticulos(string Eliminado, string Dominio, string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    bool Eliminados = false;
                    try
                    {
                        Eliminados = int.Parse(Eliminado) == 0 ? false : true;
                    }
                    catch { }

                    Seccion elemento = new Seccion();
                    elemento.id_secc = 0;

                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetSubmayorArticulos(elemento, Eliminados, iden));
                }
                else
                {
                    throw new Exception(L.LBL("LblGENWrongUserSession"));
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(ex.Message, 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = ex.Message,
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + ":</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #endregion

        #region Point of Sales

        #region Articulos

        [WebGet]
        [OperationContract]
        public string GetArticulosGrid_POS(string ArtBusqueda, string Opcion, string Dominio, string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    bool Eliminados = false;

                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetArticulosGrid_POS(ArtBusqueda, Opcion, Eliminados, iden));
                }
                else
                {
                    throw new Exception(L.LBL("LblGENWrongUserSession"));
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(ex.Message, 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = ex.Message,
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + ":</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }


        #endregion

        #endregion

        #region Management

        [WebGet]
        [OperationContract]
        public string ConsultarAplicacionesCombo(string IdModulo, string Elegir, string U, string N, string D, string I)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    return HTMLSelects.Aplicaciones(int.Parse(IdModulo), "", int.Parse(Elegir), "", iden);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\">" + L.LBL("LblGENWrongQuery") + "</br> " + Memoria.Error + "\n" + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #region Bitácora de Seguridad

        [WebGet]
        [OperationContract]
        public string GetAplicacionesCombo(string id_modulo, string I, string LangCode)
        {
            try
            {
                if (Seguridad.CargarConfiguracionManagement() == 1)
                {
                    return HTMLSelects.Aplicaciones(int.Parse(id_modulo));
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>Hubo un problema con la consulta:</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        [WebGet]
        [OperationContract]
        public string GetDatosComboBS(string id_modulo, string I, string LangCode)
        {
            try
            {
                if (Seguridad.CargarConfiguracionManagement() == 1)
                {
                    return HTMLSelects.DatosLog(int.Parse(id_modulo));
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>Hubo un problema con la consulta:</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        [WebGet]
        [OperationContract]
        public string GetOpcionesCombo(string id_app, string I, string LangCode)
        {
            try
            {
                if (Seguridad.CargarConfiguracionManagement() == 1)
                {
                    return HTMLSelects.Opciones(int.Parse(id_app));
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>Hubo un problema con la consulta:</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #endregion

        #region Front Desk

        #region Históricos - Habitaciones

        [WebGet]
        [OperationContract]
        public string GetHISTHabitaciones(string Fil_id_habi, string vFil_id_habi, string vFil_id_habi2, string Fil_fecha_ent, string vFil_fecha_ent, string vFil_fecha_ent2
            , string Fil_fecha_sal, string vFil_fecha_sal, string vFil_fecha_sal2, string Fil_fecha_estancia, string vFil_fecha_estancia, string vFil_fecha_estancia2
            , string Fil_id_agen, string vFil_id_agen, string Fil_id_cont, string vFil_id_cont, string Fil_id_merc, string vFil_id_merc, string Fil_id_venta
            , string vFil_id_venta, string Fil_nro_reserva, string vFil_nro_reserva, string Fil_nro_rooming, string vFil_nro_rooming, string Fil_id_ralo
            , string vFil_id_ralo, string Fil_id_mone, string vFil_id_mone, string Fil_id_thab, string vFil_id_thab, string Fil_vip, string vFil_vip
            , string Fil_credito, string vFil_credito, string Fil_id_oper, string vFil_id_oper, string Fil_referencia, string vFil_referencia, string Fil_grupo
            , string vFil_grupo, string Fil_nro_faca, string vFil_nro_faca, string Fil_observaciones, string vFil_observaciones, string Fil_id_care, string vFil_id_care
            , string Fil_check_in_anul, string Fil_salidas_hotelera, string Fil_id_origen, string vFil_id_origen, string Fil_nombre_reserv, string vFil_nombre_reserv
            , string detallar_estancias, string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    HISTHabitacion elemento = new HISTHabitacion(false, 0, 0, false, DateTime.Now, DateTime.Now, false, DateTime.Now, DateTime.Now
                        , false, DateTime.Now, DateTime.Now, false, 0, false, 0, false, 0, false, 0, false, 0, false, 0, false, 0, false, 0, false, 0
                        , false, false, false, false, false, 0, false, "", false, "", false, 0, false, "", false, 0, false, false, false, 0, false, "", false);

                    ///////////////////////////////////////////////
                    elemento.Fil_id_habi = false;
                    try
                    {
                        elemento.Fil_id_habi = int.Parse(Fil_id_habi) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_habi = int.Parse(vFil_id_habi);
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_habi2 = int.Parse(vFil_id_habi2);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_fecha_ent = false;
                    try
                    {
                        elemento.Fil_fecha_ent = int.Parse(Fil_fecha_ent) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_ent = DateTime.Parse(vFil_fecha_ent);
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_ent2 = DateTime.Parse(vFil_fecha_ent2);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_fecha_sal = false;
                    try
                    {
                        elemento.Fil_fecha_sal = int.Parse(Fil_fecha_sal) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_sal = DateTime.Parse(vFil_fecha_sal);
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_sal2 = DateTime.Parse(vFil_fecha_sal2);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_fecha_estancia = false;
                    try
                    {
                        elemento.Fil_fecha_estancia = int.Parse(Fil_fecha_estancia) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_estancia = DateTime.Parse(vFil_fecha_estancia);
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_estancia2 = DateTime.Parse(vFil_fecha_estancia2);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_id_agen = false;
                    try
                    {
                        elemento.Fil_id_agen = int.Parse(Fil_id_agen) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_agen = int.Parse(vFil_id_agen);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_id_cont = false;
                    try
                    {
                        elemento.Fil_id_cont = int.Parse(Fil_id_cont) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_cont = int.Parse(vFil_id_cont);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_id_merc = false;
                    try
                    {
                        elemento.Fil_id_merc = int.Parse(Fil_id_merc) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_merc = int.Parse(vFil_id_merc);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_id_venta = false;
                    try
                    {
                        elemento.Fil_id_venta = int.Parse(Fil_id_venta) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_venta = int.Parse(vFil_id_venta);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_nro_reserva = false;
                    try
                    {
                        elemento.Fil_nro_reserva = int.Parse(Fil_nro_reserva) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_nro_reserva = int.Parse(vFil_nro_reserva);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_nro_rooming = false;
                    try
                    {
                        elemento.Fil_nro_rooming = int.Parse(Fil_nro_rooming) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_nro_rooming = int.Parse(vFil_nro_rooming);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_id_ralo = false;
                    try
                    {
                        elemento.Fil_id_ralo = int.Parse(Fil_id_ralo) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_ralo = int.Parse(vFil_id_ralo);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_id_mone = false;
                    try
                    {
                        elemento.Fil_id_mone = int.Parse(Fil_id_mone) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_mone = int.Parse(vFil_id_mone);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_id_thab = false;
                    try
                    {
                        elemento.Fil_id_thab = int.Parse(Fil_id_thab) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_thab = int.Parse(vFil_id_thab);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_vip = false;
                    try
                    {
                        elemento.Fil_vip = int.Parse(Fil_vip) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_vip = int.Parse(vFil_vip) == 1 ? true : false;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_credito = false;
                    try
                    {
                        elemento.Fil_credito = int.Parse(Fil_credito) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_credito = int.Parse(vFil_credito) == 1 ? true : false;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_id_oper = false;
                    try
                    {
                        elemento.Fil_id_oper = int.Parse(Fil_id_oper) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_oper = int.Parse(vFil_id_oper);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_referencia = false;
                    try
                    {
                        elemento.Fil_referencia = int.Parse(Fil_referencia) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_referencia = vFil_referencia;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_grupo = false;
                    try
                    {
                        elemento.Fil_grupo = int.Parse(Fil_grupo) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_grupo = vFil_grupo;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_nro_faca = false;
                    try
                    {
                        elemento.Fil_nro_faca = int.Parse(Fil_nro_faca) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_nro_faca = int.Parse(vFil_nro_faca);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_observaciones = false;
                    try
                    {
                        elemento.Fil_observaciones = int.Parse(Fil_observaciones) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_observaciones = vFil_observaciones;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_id_care = false;
                    try
                    {
                        elemento.Fil_id_care = int.Parse(Fil_id_care) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_care = int.Parse(vFil_id_care);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_check_in_anul = false;
                    try
                    {
                        elemento.Fil_check_in_anul = int.Parse(Fil_check_in_anul) == 1 ? true : false;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_salidas_hotelera = false;
                    try
                    {
                        elemento.Fil_salidas_hotelera = int.Parse(Fil_salidas_hotelera) == 1 ? true : false;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_id_origen = false;
                    try
                    {
                        elemento.Fil_id_origen = int.Parse(Fil_id_origen) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_origen = int.Parse(vFil_id_origen);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_nombre_reserv = false;
                    try
                    {
                        elemento.Fil_nombre_reserv = int.Parse(Fil_nombre_reserv) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_nombre_reserv = vFil_nombre_reserv;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.detallar_estancias = false;
                    try
                    {
                        elemento.detallar_estancias = int.Parse(detallar_estancias) == 1 ? true : false;
                    }
                    catch { }

                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetHISTHabitaciones(1, elemento, iden).Tables[0]);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>Hubo un problema con la consulta:</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #region Históricos - Folios Externos

        [WebGet]
        [OperationContract]
        public string GetHISTFoliosExternos(string Fil_id_tarj, string vFil_id_tarj, string vFil_id_tarj2, string Fil_nombre, string vFil_nombre
            , string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    HISTFolioExterno elemento = new HISTFolioExterno(false, 0, 0, false, "");

                    elemento.Fil_id_tarj = false;
                    try
                    {
                        elemento.Fil_id_tarj = int.Parse(Fil_id_tarj) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_tarj = int.Parse(vFil_id_tarj);
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_tarj2 = int.Parse(vFil_id_tarj2);
                    }
                    catch { }

                    elemento.Fil_nombre = false;
                    try
                    {
                        elemento.Fil_nombre = int.Parse(Fil_nombre) == 1 ? true : false;
                    }
                    catch { }
                    elemento.vFil_nombre = vFil_nombre;

                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetHISTFoliosExternos(1, elemento, iden));
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>Hubo un problema con la consulta:</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #region Históricos - Clientes

        [WebGet]
        [OperationContract]
        public string GetHISTClientes(string Fil_nombre, string vFil_nombre, string Fil_id_carp, string vFil_id_carp, string Fil_pasaporte, string vFil_pasaporte
            , string Fil_id_naci, string vFil_id_naci, string Fil_ckin_anulado, string vFil_ckin_anulado, string Fil_fecha_ent, string vFil_fecha_ent, string vFil_fecha_ent2
            , string Fil_fecha_sal, string vFil_fecha_sal, string vFil_fecha_sal2, string Fil_salidas_hotelera, string vFil_salidas_hotelera, string Fil_adulto, string vFil_adulto
            , string Fil_genero, string vFil_genero, string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    HISTCliente elemento = new HISTCliente(false, "", false, 0, false, "", false, 0, false, false, DateTime.Now, DateTime.Now, false
                        , DateTime.Now, DateTime.Now, false, false, false, false, false);

                    ///////////////////////////////////////////////
                    elemento.Fil_nombre = false;
                    try
                    {
                        elemento.Fil_nombre = int.Parse(Fil_nombre) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_nombre = vFil_nombre;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_id_carp = false;
                    try
                    {
                        elemento.Fil_id_carp = int.Parse(Fil_id_carp) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_carp = int.Parse(vFil_id_carp);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_pasaporte = false;
                    try
                    {
                        elemento.Fil_pasaporte = int.Parse(Fil_pasaporte) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_pasaporte = vFil_pasaporte;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_id_naci = false;
                    try
                    {
                        elemento.Fil_id_naci = int.Parse(Fil_id_naci) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_id_naci = int.Parse(vFil_id_naci);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_ckin_anulado = false;
                    try
                    {
                        elemento.Fil_ckin_anulado = int.Parse(Fil_ckin_anulado) == 1 ? true : false;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_fecha_ent = false;
                    try
                    {
                        elemento.Fil_fecha_ent = int.Parse(Fil_fecha_ent) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_ent = DateTime.Parse(vFil_fecha_ent);
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_ent2 = DateTime.Parse(vFil_fecha_ent2);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_fecha_sal = false;
                    try
                    {
                        elemento.Fil_fecha_sal = int.Parse(Fil_fecha_sal) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_sal = DateTime.Parse(vFil_fecha_sal);
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_sal2 = DateTime.Parse(vFil_fecha_sal2);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_salidas_hotelera = false;
                    try
                    {
                        elemento.Fil_salidas_hotelera = int.Parse(Fil_salidas_hotelera) == 1 ? true : false;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_adulto = false;
                    try
                    {
                        elemento.Fil_adulto = int.Parse(Fil_adulto) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_adulto = int.Parse(vFil_adulto) == 1 ? true : false;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_genero = false;
                    try
                    {
                        elemento.Fil_genero = int.Parse(Fil_genero) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_genero = int.Parse(vFil_genero) == 1 ? true : false;
                    }
                    catch { }

                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetHISTClientes(1, elemento, iden).Tables[0]);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>Hubo un problema con la consulta:</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #region Históricos - Repitentes

        [WebGet]
        [OperationContract]
        public string GetHISTRepitentes(string Fil_nombre, string Fil_perfil, string Fil_pasaporte
            , string Fil_fecha_ent, string vFil_fecha_ent, string vFil_fecha_ent2, string Fil_fecha_sal, string vFil_fecha_sal, string vFil_fecha_sal2
            , string Fil_estancias, string vFil_estancias, string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    HISTRepitente elemento = new HISTRepitente(false, false, false, false, DateTime.Now, DateTime.Now, false, DateTime.Now, DateTime.Now, false, 0);

                    ///////////////////////////////////////////////
                    elemento.Fil_nombre = false;
                    try
                    {
                        elemento.Fil_nombre = int.Parse(Fil_nombre) == 1 ? true : false;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_perfil = false;
                    try
                    {
                        elemento.Fil_perfil = int.Parse(Fil_perfil) == 1 ? true : false;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_pasaporte = false;
                    try
                    {
                        elemento.Fil_pasaporte = int.Parse(Fil_pasaporte) == 1 ? true : false;
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_fecha_ent = false;
                    try
                    {
                        elemento.Fil_fecha_ent = int.Parse(Fil_fecha_ent) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_ent = DateTime.Parse(vFil_fecha_ent);
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_ent2 = DateTime.Parse(vFil_fecha_ent2);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_fecha_sal = false;
                    try
                    {
                        elemento.Fil_fecha_sal = int.Parse(Fil_fecha_sal) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_sal = DateTime.Parse(vFil_fecha_sal);
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_fecha_sal2 = DateTime.Parse(vFil_fecha_sal2);
                    }
                    catch { }
                    ///////////////////////////////////////////////
                    elemento.Fil_estancias = false;
                    try
                    {
                        elemento.Fil_estancias = int.Parse(Fil_estancias) == 1 ? true : false;
                    }
                    catch { }
                    try
                    {
                        elemento.vFil_estancias = int.Parse(vFil_estancias);
                    }
                    catch { }

                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetHISTRepitentes(1, elemento, iden).Tables[0]);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>Hubo un problema con la consulta:</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #region Tipos de Habitaciones

        [WebGet]
        [OperationContract]
        public string GetTipoHabitacionesCodigoJQGrid(string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    DataTable dt = Logica.GetTipoHabitacionesCombo(iden);
                    DataTable dt2 = new DataTable();
                    dt2.Columns.Add(new DataColumn("tipo_hab"));
                    foreach (DataRow dr in dt.Rows)
                    {
                        DataRow dr2 = dt2.NewRow();
                        dr2["tipo_hab"] = dr["tipo_hab"].ToString().Trim();
                        dt2.Rows.Add(dr2);
                    }
                    return jqGridGenie.DataTableToJQGridJSON(dt2);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>Hubo un problema con la consulta:</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        [WebGet]
        [OperationContract]
        public string GetTipoHabitacionesIDCodigoJQGrid(string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    DataTable dt = Logica.GetTipoHabitacionesCombo(iden);
                    DataTable dt2 = new DataTable();
                    dt2.Columns.Add(new DataColumn("id_thab"));
                    dt2.Columns.Add(new DataColumn("tipo_hab"));
                    foreach (DataRow dr in dt.Rows)
                    {
                        DataRow dr2 = dt2.NewRow();
                        dr2["id_thab"] = dr["id_thab"];
                        dr2["tipo_hab"] = dr["tipo_hab"].ToString().Trim();
                        dt2.Rows.Add(dr2);
                    }
                    return jqGridGenie.DataTableToJQGridJSON(dt2);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>Hubo un problema con la consulta:</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #region FDK - Tipos de Cobro

        [WebGet]
        [OperationContract]
        public string GetTipoCobrosCodigoJQGrid(string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    DataTable dt = Logica.GetTipoCobrosCombo(0, 0, iden);
                    DataTable dt2 = new DataTable();
                    dt2.Columns.Add(new DataColumn("cod_tcob"));
                    foreach (DataRow dr in dt.Rows)
                    {
                        DataRow dr2 = dt2.NewRow();
                        dr2["cod_tcob"] = dr["cod_tcob"].ToString().Trim();
                        dt2.Rows.Add(dr2);
                    }
                    return jqGridGenie.DataTableToJQGridJSON(dt2);
                }
                else
                {
                    throw new Exception("No se pudo verificar la sesión del usuario");
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(L.ERR(ex.Message).Replace("[", "").Replace("]", ""), 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = L.ERR(ex.Message).Replace("[", "").Replace("]", ""),
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>Hubo un problema con la consulta:</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion

        #endregion

        #region Configuración del Usuario

        [WebGet]
        [OperationContract]
        public string PutConfiguracionUsuario(string IdOperador, string impresora, string impresora_cheq, string impresora_fact, string impresora_rec
            , string Eliminado, string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    ConfigUsuario elemento = new ConfigUsuario();
                    elemento.IdOperador = iden.U;
                    elemento.impresora = impresora;
                    elemento.impresora_cheq = impresora_cheq;
                    elemento.impresora_fact = impresora_fact;
                    elemento.impresora_rec = impresora_rec;

                    int res = -1;

                    res = Logica.PutConfiguracionUsuario(elemento, iden);

                    return res != -2147483647 ? res.ToString() : L.ERR("LblGENUserNotAuthorized");
                }
                else
                {
                    throw new Exception(L.LBL("LblGENWrongUserSession"));
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(ex.Message, 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = ex.Message,
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + ":</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }


        #endregion

        #region Impresión Directa de Documentos (IDD)

        [WebGet]
        [OperationContract]
        public string GetImpresoras(string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    return Globals.jqGridGenie.DataTableToJQGridJSON(Logica.GetImpresoras(iden))
                        .Replace("LblGENFactura", L.LBL("LblGENFactura"))
                        .Replace("LblGENRecibo", L.LBL("LblGENRecibo"))
                        .Replace("LblGENCheque", L.LBL("LblGENCheque"))
                        .Replace("LblREPPreimpresionFolio", L.REP("LblREPPreimpresionFolio"))
                        .Replace("LblFDKPCIERFacturasEmpresas", L.LBL("LblFDKPCIERFacturasEmpresas"))
                        .Replace("LblFDKProforma", L.LBL("LblFDKProforma"))
                        .Replace("LblREPDepAdelEF", L.REP("LblREPDepAdelEF"))
                        .Replace("LblREPDepAdelTarj", L.REP("LblREPDepAdelTarj"))
                        .Replace("OFCanje", L.TIT("OFCanje"))
                        .Replace("Prepagos", L.TIT("Prepagos"))
                        .Replace("Notas", L.TIT("Notas"))
                        .Replace("Reservas", L.TIT("Reservas"))
                        .Replace("RoomingList", L.TIT("RoomingList"))
                        .Replace("TarjetaRegistro", L.TIT("TarjetaRegistro"))
                        .Replace("LblGENDocumentos", L.LBL("LblGENDocumentos"));
                }
                else
                {
                    throw new Exception(L.LBL("LblGENWrongUserSession"));
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(ex.Message, 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = ex.Message,
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + ":</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        [WebGet]
        [OperationContract]
        public string PutImpresoras(string id_repo, string descripcion, string tipo_impresora, string id_papel, string Eliminado
            , string U, string N, string D, string I, string LangCode)
        {
            try
            {
                Identidad iden = new Identidad(int.Parse(Enigma.Desencriptar(U)), Enigma.Desencriptar(N), int.Parse(Enigma.Desencriptar(D)), Enigma.Desencriptar(I));

                if ((Seguridad.CargarConfiguracionManagement() == 1) && (Seguridad.VerificarSesion(U, N, 1, D, I)))
                {
                    Impresora elemento = new Impresora();
                    try
                    {
                        elemento.id_repo = int.Parse(id_repo);
                    }
                    catch
                    {
                        elemento.id_repo = 0;
                    }
                    elemento.descripcion = descripcion;
                    elemento.tipo_impresora = int.Parse(tipo_impresora);
                    elemento.id_papel = int.Parse(id_papel);

                    elemento.eliminado = int.Parse(Eliminado) == 1 ? true : false;

                    int res = -1;

                    res = Logica.PutImpresoras(elemento, iden);

                    return res != -2147483647 ? res.ToString() : L.ERR("LblGENUserNotAuthorized");
                }
                else
                {
                    throw new Exception(L.LBL("LblGENWrongUserSession"));
                }
            }
            catch (Exception ex)
            {
                #region Manejo de Errores (Administrador)

                var metodo = MethodBase.GetCurrentMethod().Name;
                var msgError = string.Format(MssgTrace.Trace_Message_Error, metodo, ex);
                LogGenie.ErrorLogSave(ex.Message, 16, msgError, System.Diagnostics.TraceEventType.Error);

                #endregion

                #region Manejo de Errores (Base de Datos)

                try
                {
                    var xException = new Excepcion
                    {
                        EventID = 0,
                        Priority = 16,
                        Severity = TraceEventType.Error,
                        Title = ex.Message,
                        Timestamp = DateTime.Now,
                        MachineName = Environment.MachineName,
                        AppDomainName = Environment.UserDomainName,
                        ProcessID = string.Empty,
                        ProcessName = Environment.CommandLine,
                        ThreadName = string.Empty,
                        Message = ex.ToString()
                    };

                    Logica logica = new Logica();
                    logica.DataBaseLogError(xException);
                }
                catch
                {
                }

                #endregion

                return "<p class=\"SevenMsgError\"><b>" + L.LBL("LblGENWrongQuery") + ":</b></br> " + L.ERR(ex.Message).Replace("[", "").Replace("]", "") + "</p>";
            }
        }

        #endregion
    }
}

